﻿Imports System.Runtime.InteropServices

Public Class Form1
    Private Sub Form1_Shown(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles Me.Shown

        Dim o As New IO.DirectoryInfo( _
            System.Windows.Forms.Application.StartupPath)
        LoadNewPicture(o.Parent.Parent.FullName & "\P8301141.JPG")
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles Button1.Click

        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            LoadNewPicture(OpenFileDialog1.FileName)
        End If
    End Sub

    Private Sub LoadNewPicture(ByVal FullName As String)
        Dim bmp As New Bitmap(FullName)

        PictureBox1.Image = bmp
        Dim c As UInt32 = CountColors(bmp)
        MessageBox.Show("Das Bild enthält " & c & " unterschiedliche Farben.")
    End Sub

    Private Function CountColors(ByVal InBitmap As Bitmap) As UInt32
        ' Um komfortabler durch die Bilddaten iterieren zu können, wird das Bild
        ' zuerst in 32Bit Farbtiefe konvertiert:
        Dim dwPixels(InBitmap.Height * InBitmap.Width - 1) As UInt32
        Dim hPixels As GCHandle = GCHandle.Alloc(dwPixels, GCHandleType.Pinned)
        Dim bmp32Bpp As New Bitmap(InBitmap.Width, _
            InBitmap.Height, InBitmap.Width * 4, _
            Imaging.PixelFormat.Format32bppRgb, hPixels.AddrOfPinnedObject)

        Using gr As Graphics = Graphics.FromImage(bmp32Bpp)
            gr.DrawImageUnscaledAndClipped(InBitmap, New Rectangle(0, 0, _
                bmp32Bpp.Width, bmp32Bpp.Height))
        End Using

        ' Jetzt zählen:
        Dim dwTable(CInt(2 ^ 19) - 1) As Int32
        Dim index As Int32
        Dim bit As Int32
        Dim cDifferentColors As UInt32
        For i = 0 To dwPixels.Length - 1
            ' das höchstwertige Byte ist unbenutzt und muss ausmaskiert werden:
            index = CInt(dwPixels(i) And &HFFFFFF)
            bit = 1 << (index And &H1F)
            index >>= 5

            If (dwTable(index) And bit) = 0 Then
                cDifferentColors += 1UI
                dwTable(index) = dwTable(index) Or bit
            End If
        Next

        ' GC Handle freigeben:
        hPixels.Free()

        Return cDifferentColors
    End Function
End Class
